Subject: Re: [PATCH] veth: replace iflink by a dedicated symlink in sysfs

From: Nicolas Dichtel <[email-masked]>
Date: Wed, 19 Aug 2015 18:33:14 +0200

Le 19/08/2015 14:48, Vincent Bernat a écrit :
>   ❦ 19 août 2015 14:38 +0200, Jiri Benc <[email-masked]> :
>
>>> That's the main goal of this patch: advertising the peer link as
>>> IFLA_LINK attribute triggers an infinite loop in userland software when
>>> they follow iflink to discover network devices topology. iflink has
>>> always been the index of a lower device. If a sysfs symbolic link is not
>>> good enough, I can propose a new IFLA_PEER attribute instead.
>>
>> This would cause regression and break applications for those of us who
>> started relying on the netnsid feature to match interfaces across net
>> name spaces.
>
> Yes. Unfortunately.
>
>> This is tough. If you're going to do such thing, you would at least
>> need to also introduce IFLA_PEER_NETNSID.
Probably better to introduce veth netlink attribute then, something like
IFLA_VETH_PEER and keeps IFLA_LINK_NETNSID.

>
> Yes I can.
>
> In my opinion, the change of semantics of IFLA_LINK is a break of
> API. However, I can live with it since it's easy to workaround it. It
> just seemed easier to start the discussion with a patch.
>
I also don't know what is the best way to handle this. veth advertises
its peer via IFLA_LINK since 4.1, so it's too late to change it for this
release.